import requests
import json
import random
import string

client_id = input("请输入client_id:")
tenant_id = input("请输入tenant_id:")
client_secret = input("请输入client_secret:")
usageLocation = input("请输入usageLocation(不清楚输入CN):")

url = 'https://login.microsoftonline.com/' + tenant_id + '/oauth2/v2.0/token'
scope = 'https://graph.microsoft.com/.default'
data = {
    'grant_type': 'client_credentials',
    'client_id': client_id,
    'client_secret': client_secret,
    'scope': scope
}
r = requests.post(url, data)
token = r.json()['access_token']

header = {
    'Authorization': 'Bearer ' + token,
    'Content-Type': 'application/json'
}


def add_passwd():
    response = requests.get('https://graph.microsoft.com/v1.0/applications', headers=header)
    id = ""
    response = response.json()

    for roles in response['value']:
        if roles['appId'] == client_id:
            id = roles['id']
            break
    post_data = {
        "passwordCredential": {
            "displayName": "test",
            "endDateTime": "2999-04-18T07:02:00.762Z",
            "startDateTime": "2021-04-18T07:02:07.961Z"}
    }
    print(requests.post('https://graph.microsoft.com/v1.0/applications/' + id + '/addPassword',
                        data=json.dumps(post_data), headers=header).json())


def create_user():
    data = requests.get('https://graph.microsoft.com/v1.0/domains', headers=header)
    data = data.json()
    for item in data['value']:
        if item.get('isDefault'):
            domain = item.get('id')
            break
    pwd = ''.join(random.choices(string.ascii_letters + string.digits + '!#$%&*+-/:;?@', k=13))
    user_name = ''.join(random.choices(string.ascii_letters, k=6))
    user_email = f'{user_name}@{domain}'
    post_data = {
        'accountEnabled': True,
        'displayName': user_name,
        'mailNickname': user_name,
        'passwordPolicies': 'DisablePasswordExpiration, DisableStrongPassword',
        'passwordProfile': {
            'password': pwd,
            'forceChangePasswordNextSignIn': False
        },
        'userPrincipalName': user_email,
        'usageLocation': usageLocation
    }
    requests.post('https://graph.microsoft.com/v1.0/users', data=json.dumps(post_data), headers=header)
    print(f'{user_email}: {pwd} 创建完成.')
    return user_email, pwd


def make_admin():
    response = requests.get("https://graph.microsoft.com/v1.0/directoryRoles", headers=header)
    response = response.json()
    rid = ""
    for roles in response['value']:
        if roles['displayName'] == "Global Administrator":
            rid = roles['id']
            break
    user, password = create_user()
    data = requests.get('https://graph.microsoft.com/v1.0/users/' + user, headers=header).json()
    post_data = {
        "@odata.id": "https://graph.microsoft.com/v1.0/directoryObjects/" + data['id']
    }
    data_request = requests.post('https://graph.microsoft.com/v1.0/directoryRoles/' + rid + '/members/$ref',
                         data=json.dumps(post_data), headers=header)
    if data_request.status_code == 204:
        print("升级全局管理成功")
    else:
        print("升级全局管理失败，请检查权限或者重试")


while True:
    print("0.退出")
    print("1.增加应用密钥")
    print("2.增加全局管理")
    choice = input("输入选项:")
    if choice[0] == '0':
        break
    if choice[0] == '1':
        add_passwd()
    if choice[0] == '2':
        make_admin()